//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
// STEAR 2010-2013
//--------------------------------------------------------------
// freeze owataBGMt@C[x[Xɂ摜r[B
// intraFontx[X̃C^[tF[XɕύXB
//--------------------------------------------------------------

#include <pspdisplay.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <pspgu.h>
#include <psppower.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FreezeViewer.h"
#include "fvTool.h"
#include "fileList.h"
#include "mp3Audio.h"
#include "psp2chIni.h"
#include "intraFont.h"
#include "fvDraw.h"
#include "SMEMO/zenkaku.h"
#include "dialog.h"
#include "sound.h"

//------ 萔 -----

#define	VERSION		"0.90"

//------ s[hw -----

PSP_MODULE_INFO( "freeze viewer", PSP_MODULE_USER, 0, 8 );
PSP_MAIN_THREAD_ATTR( PSP_THREAD_ATTR_USER );
PSP_HEAP_SIZE_KB( -512 );										// ꉞAPIƂ512KBcĂ

//----- O[oϐ -----

extern S_2CH	s2ch;											// fvTool.c
volatile int	gExitRequest = 0;								// PSP
volatile int	gDialogFlag = 0;								// _CAO\Ă邩i0:Noj
volatile int	gListDrawFlag = 0;								// ListDrawi0:Noj_CAO֘AtO
DrawImg			*gScrBuf1;										// wiޔ̈
DrawImg			*gScrMask, *gScrMask2;							// wip
DrawImg			*gCsrImg;										// J[\p
DrawImg			*gEtcImg;										// ėp
DrawImg			*gIconImg[10];									// ACRp
DrawImg			*gRollBar;										// XN[o[p

void SMEMOinit(iniList *ini);									// PSP
void SMEMOend(void);											// PSP


//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;											// PSP
	sceKernelExitGame();
	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int power_callback(int unknown, int pwrflags, void *common)
{
	/* check for power switch and suspending as one is manual and the other automatic */
	if (pwrflags & PSP_POWER_CB_POWER_SWITCH || pwrflags & PSP_POWER_CB_SUSPENDING) {
		audioStop();
	} else if (pwrflags & PSP_POWER_CB_RESUMING) {
	} else if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE) {
	} else if (pwrflags & PSP_POWER_CB_STANDBY) {
	} else {
	}
	sceDisplayWaitVblankStart();

	return 0;
}

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback( "Exit Callback", exit_callback, NULL );
	sceKernelRegisterExitCallback( cbid );
	cbid = sceKernelCreateCallback( "Power Callback", power_callback, NULL );
	scePowerRegisterCallback( 0, cbid );
	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// sleep thread
//--------------------------------------------------------------

int sleep_thread(SceSize args, void *argp)
{
	SceCtrlData	pad,pad2;
	int			count;

	sceCtrlSetSamplingCycle( 0 );
	sceCtrlSetSamplingMode( PSP_CTRL_MODE_ANALOG );
	count = 0;
	pad2.Buttons = 0;
	pad2.Lx = pad2.Ly = 128;

	while (1) {
		sceCtrlReadBufferPositive( &pad, 1 );
		if (pad.Buttons & PSP_CTRL_HOLD || pad.Buttons != pad2.Buttons || abs(pad.Lx-pad2.Lx)>32 || abs(pad.Ly-pad2.Ly)>32) {
			count = 0;											// {^ĂJE^Zbg
		}
		pad2 = pad;
		count++;
		if (count > s2ch.cfg.sleep * 60 * 2) {					// w莞Ԍo߂TXyhV[PXN
			count = 0;
			if (s2ch.cfg.sleep) {								// TXyhԂ0ȂTXyhȂ
				scePowerTick( 0 );								// TXyh
				scePowerRequestSuspend();						// TXyhv
			}
		}

		sceKernelDelayThread( 500000 );							// 0.5b҂
	}

    return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread( "update_thread", CallbackThread, 0x11, 0x0FA0, 0, 0 );
	if (thid >= 0) {
		sceKernelStartThread( thid, 0, 0 );
	}
	thid = sceKernelCreateThread( "sleep_thread", sleep_thread, 32, 0x800, 0, NULL );
	if (thid >= 0) {
		sceKernelStartThread( thid, 0, 0 );
	}
	return thid;
}


//==============================================================
// ݒXbh
//--------------------------------------------------------------

static int InitThread(SceSize args, void *argp)
{
	int		err;
	iniList	*ini = *((iniList**)argp);

	sceIoChdir( s2ch.cwDir );
	SMEMOinit(ini);															// PSP
	ini->phase++;
	audioInit( ini );
	ini->phase++;
	gIconImg[2] = (DrawImg*)loadImage( "image/̑ACR.png" );		// ACRp
	gIconImg[3] = (DrawImg*)loadImage( "image/摜ACR.png" );			// ACRp
	gIconImg[4] = (DrawImg*)loadImage( "image/yACR.png" );			// ACRp
	gIconImg[5] = (DrawImg*)loadImage( "image/eLXgACR.png" );		// ACRp
	gIconImg[6] = (DrawImg*)loadImage( "image/XeACR.png" );		// ACRp
	gIconImg[7] = (DrawImg*)loadImage( "image/{̃[ACR.png" );	// ACRp
	gIconImg[8] = (DrawImg*)loadImage( "image/ݒACR.png" );			// ACRp
	gIconImg[9] = (DrawImg*)loadImage( "image/ڃACR.png" );			// ACRp
	if (gIconImg[2]==NULL || gIconImg[3]==NULL || gIconImg[4]==NULL || gIconImg[5]==NULL ||
	    gIconImg[6]==NULL || gIconImg[7]==NULL || gIconImg[8]==NULL || gIconImg[9]==NULL) {
		strcpy( ini->msg[ini->phase], "ACR摜̓ǂݍ݂Ɏs܂" );
		ini->error = -1;													// N~
	}
	ini->phase++;
	err = sound_setup();
	if (err != 1) {
		sprintf( ini->msg[ini->phase], "SEt@C̓ǂݍ݂Ŗ肪o܂(%d)", -err );
	}
	ini->phase++;
	psp2chIniLoadConfig();
	return 0;
}


//==============================================================
// ZbgAbv̉ʕ\
//--------------------------------------------------------------
// INILIST̒`"FreezeViewer.h"
//--------------------------------------------------------------

static void iniDraw(iniList *ini)
{
	const char	*iniName[INILIST] = {"intraFont[h", "PSPݒ[h", "monafont[h",
	                                 "t@C[h", "freeze viewerݒ[h", "AV module[h",
	                                 "ACRC[W[h", "SEt@C[h"};
	static float	y[INILIST];
	static int		setup, timing, pos;
	char			msg[128];
	int				i, yp;
	float			yv;

	if (setup == 0) {											// ݒ
		setup = 1;
		for (i = 0; i < INILIST; i++) {
			y[i] = -1;
		}
	}

	fillScreenRect( s2ch.BakCor, 0, 0, 480, 272 );

	for (i = 0; i < INILIST; i++) {								// Xg
		if (y[i] >= 0) {
			yv = (i * 14 - y[i]) / 6;
			y[i] += yv;
			yp = y[i];
			strcpy( msg, iniName[i] );
			if (ini->phase > i) {
				mh_print( 5, yp, msg, 0x808080 );
				if (ini->msg[i][0] == '\0') {
					mh_print( 5+13*12, yp, "OK", 0xFFC0C0 );
				} else {
					mh_print( 5+13*12, yp, ini->msg[i], 0xC0C0FF );
				}
			} else if (ini->phase == i) {
				mh_print( 5, yp, msg, 0xFFFFFF );
			} else {
				mh_print( 5, yp, msg, 0x808080 );
			}
		}
	}

	if (timing <= 0) {											// Xgo^C~O
		timing = 7;
		if (pos < INILIST) {
			y[pos++] = 272;
		}
	}
	timing--;
}

//==============================================================
// main
//--------------------------------------------------------------

int main(int argc, char *argv[])
{
	iniList		iniDat ,*ini;
	DrawImg		mask;
	char	*ch, msg[256];
	int		i, j, thid;

	strcpy( s2ch.cwDir, argv[0] );
	ch = strrchr( s2ch.cwDir, '/' );
	*ch = '\0';
	SetupCallbacks();
	sceCtrlSetSamplingCycle( 0 );
	sceCtrlSetSamplingMode( PSP_CTRL_MODE_ANALOG );
	initGraphics();
	flipScreen();
	cptblSort();												// R[hϊe[ũ\[g

	gExitRequest = 0;
	gScrBuf1  = DrawImgCreate( 480, 272 );						// wiޔ̈m
	gScrMask  = DrawImgCreate( 144, 272 );						// j[wip
	gScrMask2 = DrawImgCreate( 128, 272 );						// S̔wip
	gCsrImg   = DrawImgCreate( 144, 32 );						// J[\p
	gEtcImg   = DrawImgCreate( 480, 32 );						// ėp
	gRollBar  = DrawImgCreate( 8, 272 );						// XN[o[p
	gIconImg[0] = DrawImgCreate( 64, 48 );						// ACRp
	gIconImg[1] = DrawImgCreate( 64, 48 );						// ACRp

	if (gScrBuf1==NULL || gScrMask==NULL || gScrMask2==NULL ||
	    gCsrImg==NULL || gIconImg[0]==NULL || gIconImg[1]==NULL) {
		pspShowMessageDialog( "Ɨpobt@̊mۂɎs܂\nI܂" );
		goto END;
	}

	s2ch.BakCor = 0x00104010;

	//----- ef[^̃ZbgAbv -----

	for (i = 0; i < INILIST; i++) {
		iniDat.msg[i][0] = '\0';
	}
	thid = sceKernelCreateThread( "init_thread", (SceKernelThreadEntry)&InitThread, 0x30, 0x2000, 0, NULL );
	if (thid < 0) goto END;
	ini = &iniDat;
	ini->phase = 0;
	ini->error = 0;
	sceKernelStartThread( thid, sizeof(iniList**), (void*)&ini );
	while (!gExitRequest) {
		iniDraw( ini );
		if (sceKernelGetThreadExitStatus(thid) >= 0) break;
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}
	BoxFillImage( gIconImg[0], 0, 0 , 30  , 10   , 0xA000FFFF );
	BoxFillImage( gIconImg[0], 0, 10, 64  , 48-10, 0xA000FFFF );
	BoxFillImage( gIconImg[0], 2, 12, 64-4, 48-14, 0x5000FFFF );	// tH_ACR
	BoxFillImage( gIconImg[1], 0, 0 , 30  , 10   , 0xA000FF00 );
	BoxFillImage( gIconImg[1], 0, 10, 64  , 48-10, 0xA000FF00 );
	BoxFillImage( gIconImg[1], 2, 12, 64-4, 48-14, 0x5000FF00 );	// A[JCuACR
//	BoxFillImage( gIconImg[2], 0, 0 , 64  , 38   , 0xA0FFFFFF );
//	BoxFillImage( gIconImg[2], 2, 2 , 64-4, 38-4 , 0x50FFFFFF );	// ̑t@CACR
	sceKernelDeleteThread(thid);
	iniDraw(ini);
	ScreenView();												// ʍXV
	if (iniDat.error < 0) {
		pspShowMessageDialog( "ZbgAbvŖ肪܂\n̂܂܂ł͑s鎖oȂߏI܂" );
		goto END;
	}
	for (i = 0; i < INILIST; i++) {
		if (strlen(iniDat.msg[i]) != 0) {
			pspShowMessageDialog( "ZbgAbvŖ肪܂̂܂ܑs܂" );
			break;
		}
	}

	//----- C ----

	fillScreenRect( s2ch.BakCor, 0, 0, 480, 272 );
	sprintf( msg, "freeze viewer ver%s", VERSION );
	guStart();
	if_printSjis( 5, 17, msg, 1.0f, 0xFFFFFF, 0x010101, 0.2f );
	if_print    ( 5, 32, "By.STEAR 2010-2017", 0.7f, 0xFFFFFF, 0x010101, 0.2f );
	sceGuFinish();
	flipScreen( 0 );
	blitScreenToImage( 0, 0, 0, 480, 272, gScrBuf1, 0, 0 );

	fileList( s2ch.cfg.imageDir );

	//----- I -----

	mask.wx = 32;
	mask.wy = 272;
	mask.width = 512;
	mask.height = 272;
	mask.data = &VRAM[0][480];
	BoxFillImage( &mask, 0, 0, 32, 272, 0xFF000000 );			// ʊOE̖\}XNp̈ƂĎgp
	ScreenCopy2(1);												// ʎ荞
	for (j = 0; j < 10; j++) {									// tF[hAEg
		ScreenPaste2();											// ޔĂʂWJ
		guStart();
		sceGuClear( GU_DEPTH_BUFFER_BIT );
		for (i = 0; i < 480/32; i++) {
			DrawPicAlpha( i*32, 0, &mask, j/9.0f, 1.0f );
		}
		sceGuFinish();
		sceGuSync( 0, 0 );
		sceDisplayWaitVblankStart();
		flipScreen( 0 );
	}

	SMEMOend();													// PSP
END:
	for (i = 9; i >= 0; i--) {
		DrawImgFree( gIconImg[i] );
	}
	DrawImgFree( gEtcImg );
	DrawImgFree( gCsrImg );
	DrawImgFree( gScrMask2 );
	DrawImgFree( gScrMask );
	DrawImgFree( gScrBuf1 );
	audioTerm();
	sceKernelExitGame();
	return 0;
}
