#ifndef _RAR_FINDDATA_
#define _RAR_FINDDATA_

#include "timefn.hpp"
#include "rartypes.hpp"

struct FindData
{
  char Name[NM];
  wchar NameW[NM];
  Int64 Size;
  uint FileAttr;
  uint FileTime;
  bool IsDir;
  RarTime mtime;
  RarTime ctime;
  RarTime atime;
  bool Error;
};

class FindFile
{
  private:

    char FindMask[NM];
    wchar FindMaskW[NM];
    int FirstCall;
    DIR *dirp;
  public:
    FindFile();
    ~FindFile();
    void SetMask(const char *FindMask);
    bool Next(struct FindData *fd,bool GetSymLink=false);
    static bool FastFind(const char *FindMask,const wchar *FindMaskW,struct FindData *fd,bool GetSymLink=false);
};

#endif
